package cytoPrefuse;

import prefuse.Visualization;
import prefuse.action.Action;
import cytoscape.Cytoscape;
import cytoscape.util.CytoscapeProgressMonitor;
import cytoscape.util.MonitoredTask;

public class CytoscapeLayoutMonitor implements MonitoredTask {

	private SearchGridLayout searchGridLayout;
	private boolean hasStarted;
	private CreateViewDialog cvd;
	private Action layout;
	private Visualization vis;
	public CytoscapeLayoutMonitor(CreateViewDialog cvd){
		this.cvd = cvd;
		hasStarted = false;
		CytoscapeProgressMonitor progressMonitor = new CytoscapeProgressMonitor(this,Cytoscape.getDesktop().getNetworkViewManager().getDesktopPane());
	
		progressMonitor.startMonitor(false);		
	}
	public boolean done() {
		
		if (!hasStarted)
			return false;
		boolean running = layout.isScheduled() || layout.isRunning();
		return !running;
	}

	public int getCurrent() {
	//	System.out.println ("GetCurrent");
		if (searchGridLayout != null)
			return searchGridLayout.getProgress();
		else 
			return 1;
	}

	public int getLengthOfTask() {		
		return 1000;
	}

	public String getMessage() {
		if (searchGridLayout != null)
			return searchGridLayout.getProgressMessage();
		return "Creating layout";
	}

	public String getTaskName() {
		return "Creating cell localization layout.";
	}

	public void go(boolean arg0) {
		System.out.println ("Go");


		final CytoPrefuse cytoPrefuse = new CytoPrefuse(cvd);
		
		//cytoPrefuse.loadNetwork();
		searchGridLayout = cytoPrefuse.searchGridLayout;
		vis= cytoPrefuse.getVisualization();			
		layout = vis.getAction("layout");
		vis.runAfter("layout", "layoutPostProcess");
		vis.run ("layout");
		vis.run("applyVizMapper");
		hasStarted = true;
	
			
	}

	public void incrementProgress() {
		System.out.println ("increment called");
	}

	public void stop() {
		vis.cancel("layout");
		vis.run("layoutPostProcess");
	}

	public void cancel() {
		vis.cancel("layout");
		vis.run("layoutPostProcess");
	}

	public boolean wasCanceled() {		
		return false;
	}

}
